#!/bin/bash
# Program makegrid.bash
# Copyright (C) Assela Pathirana
# 
# This program is free software; you can redistribute it and/or
# modify it under the terms of the GNU General Public License
# as published by the Free Software Foundation; either version 2
# of the License, or (at your option) any later version.
# 
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
# 
# You should have received a copy of the GNU General Public License
# along with this program; if not, write to the Free Software
# Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.
# #########################################################################
. /dataG/assela/cpc/CONSTANTS.bash
if [ $# -lt 1 ]; then
  echo "Plots a part of the CPC precip map "
  echo "usage: $0 <filename>  "
  echo "where filename: a text file with"
  echo "row1: file name (with full path if applicable) of CPC uncompressed data followed by a filename indicating corners in the format of the output of WRF static processing e.g. <>/wrfsi/domains/<domain>/static/corners-mass.d03.dat "
  echo "row2: box in GMT -R format "
  echo 
  exit
fi
err=0
source './plot.inc'
err=$(( $err + $? )) 
cpcundef=-999.0
tmp=tmp #tmp.$$.tmp
rm -f .gmt*
filename=(`head -n1 $1`)
echo "filename: $filename"
box=`tail -n1 $1`
if [ !  "${filename[0]}" ] || [ ! "$box" ]; then 
  echo "error in datafile in argument.."
  echo "exiting."
  exit 1
fi
tmpname=$filename.$tmp
$endianc $filename $tmpname.dat 
err=$(( $err + $? )) 
$GMT/xyz2grd   -V $tmpname.dat -I.1/.1 -R$box  -ZBLf  -G$filename.grd -N$cpcundef
err=$(( $err + $? )) 
rm -f .gmt* $tmp
if [ $err -eq 0 ]; then 
  echo "$0:`date +%Y%m%d%H%m`: returned without error"
else
  echo "$0:`date +%Y%m%d%H%m`: returned error ($err)"
fi
exit $err
